package org.basex.modules.ftp;

import org.basex.core.*;
import org.basex.query.*;
import org.basex.query.value.*;
import org.basex.query.value.item.*;

/**
 * Examples for FTP Connections.
 *
 * @author BaseX Team 2005-12, BSD License
 * @author Christian Gruen
 */
public class FTPExample {
  /**
   * Test method.
   * @param args ignored
   * @throws Exception exception
   */
  public static void main(final String[] args) throws Exception {
    java();
    xquery();
  }

  /**
   * Raw test method.
   * @throws Exception exception
   */
  static void java() throws Exception {
    final FTP ftp = new FTP();
    ftp.connect(Str.get("phobos103.inf.uni-konstanz.de")
        , Int.get(21)
        , Str.get("remo")
        , Str.get("r3m0"));
    final Value v = ftp.list(Str.get("/"));
    for(final Item i : v) {
      System.out.println(i);
    }
    ftp.disconnect();
  }

  /**
   * XQuery test method.
   * @throws Exception exception
   */
  static void xquery() throws Exception {
    final Context ctx = new Context();
    final String query =
      "import module namespace ftp = 'org.basex.modules.ftp.FTP'; " +
      "ftp:connect('phobos103.inf.uni-konstanz.de', 'remo', 'r3m0'), " +
      "for $f in ftp:list('/') return ($f || $util:nl)," +
      "if(ftp:delete('test.txt')) then () else ('Cannot delete test.txt' || out:nl())," +
      "for $f in ftp:list('/') return ($f || $util:nl)," +
      "ftp:disconnect()";

    try(final QueryProcessor qp = new QueryProcessor(query, ctx)) {
      System.out.println(qp.value());
    }
  }
}
